#!/usr/bin/perl

######################################################################
#  IIS and WinNT may require the print line below.
#  If so, just remove the # at the beginning of the line.
######################################################################
# print "HTTP/1.0 200 OK\n";

eval
 {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
 
	################################################################
	# WinNT may require the full path to the files below
	################################################################

	require "setup.pl";
	require "subs1.pl";
	require "cgi-lib.pl";
	require "date.pl";
 };


######################################################################
######################################################################
############  You should not change anyting below. ###################
######### Your script may not work properly if you do ################
######################################################################
######################################################################

&ReadParse;

$today_julian_day = &today();
$IgnorePWCheck = 1;

$useidssave = $useids;
if (!$in{id}) { undef $useids ;}

$IsEntryForm = 1;
&CheckInfo;

######################################################################
######################################################################


if ($MainEnableAll ne $CurrentVerFormat)
 {
	 	&PrintMessage(
			"$translate1", 
			"<p>$translate2</p>
			$MainShutoffReason",
			"1",
			""
			);
 }
if ( (($EnableAll ne $CurrentVerFormat) or ($UpgradeEnableAll ne $CurrentVerFormat)) && ($useids) )
 {
	 	&PrintMessage(
			"$translate1", 
			"<p>$translate3</p>
			$ShutoffReason",
			"1",
			""
			);
 }
if ($in{action} eq 'RecommendForm')
 {
	&CheckForFilename;
	&GetCookies;
	$visitor_nav = 'on';
	&RecommendForm;
 }
if ($in{action} eq 'SendRecommendEmail')
 {
	$visitor_nav = 'on';
	&SendRecommendEmail;
 }
if ($in{action} eq 'entryform')
 {
	&CheckForFilename;
	&GetCookies;
	$visitor_nav = 'on';
	&entryform;
 }
elsif
 ($in{action} eq 'SubmitEntry')
 {
	&CheckForFilename;
	&GetCookies;
	$visitor_nav = 'on';
	&SubmitEntry;
 }
elsif ($in{action} eq 'rules')
 {
	&CheckForFilename;
	$visitor_nav = 'on';
	&ShowRules;
}

if ( ($useidssave) && (!$in{id}) )
 {
 	&GetUserList;	
 }
else
 {
	#my $Save_$tpl_base = $tpl_base;
	&getcontestlist;
	#$tpl_base = $Save_$tpl_base;
	&contestenterlist;
 }
 

######################################################################
######################################################################

sub contestenterlist
 {
	
	undef $title;

	if ($useids)
	 {
		require "$contest_dir/setup.$cgiext";
		$title = $UserTitle;
	 }

	&header;
	
	if ($contestenterlist)
	 {
		$htmloutput .= qq~
			<h4>$translate4</h4>
			<blockquote>
			$contestenterlist
			</blockquote>
		~;
	 }
	
	if ($ComingEnterList)
	 {		
		$htmloutput .= qq~
		
			<h4>$translate5</h4>
			<blockquote>
			$ComingEnterList
			</blockquote>
		~;
	 }
	
	if ($expiredcontestenterlist)
	 {
		$htmloutput .= qq~
			<h4>$translate6</h4>
			<blockquote>
			$expiredcontestenterlist
			</blockquote>
		~;
	 }

	my $SaveType = $in{type};
	
	undef $in{type}; undef $filename; undef $in{filename};
	&SetGlobalQueryString;

	$htmloutput .= qq~
		<p><font size="1">
		[ <a href="$giveawayscript?$GlobalQueryString">All</a> ]
		[ <a href="$giveawayscript?$GlobalQueryString&type=Contest">Contests Only</a> ]
		[ <a href="$giveawayscript?$GlobalQueryString&type=Survey">Surveys Only</a> ]
		[ <a href="$giveawayscript?$GlobalQueryString&type=Poll">Polls Only</a> ]
		</font></p>

		$LanguageSelectOutput
	~;

	$in{type} = $SaveType;
	undef $form_tpl;
	undef $form_tpl;
	&footer;
 }

################################################
# Perform subs
################################################

sub SubmitEntry
 {

	use locale;
	
	require "$contest_dir/$in{filename}.vars.$cgiext";

	if ($LocalSubmitOnly) { &CheckLocalReferer; }

	&SetUsePairs;
	&Set_Pre_V29;
	
	if (!$contest_url) 
	 {
		$contest_url = "$giveawayscript?id=$in{id}";
	 }

	$StrippedPhone = $in{Phone}; $StrippedPhone =~ s|\D||g;
	$StrippedFax = $in{Fax}; $StrippedFax =~ s|\D||g;

	&CheckContestStatus;
	&PrintContestStatus;
	&CheckEntryRequired;
	&CheckBanned;
	&CheckDup;
	
	$status = "C";
	undef $inanswers;
	undef $IncorrectQuestions;
	
	if ($no_questions > 0)
	 {
		for ($i = 1; $i <= $no_questions; $i++)
		 {

		 	my $answer = eval "\$answer$i;";
		 	#$answer =~ tr/A-Z/a-z/;
		 	$answer =~ s/\s//g;

			$given = eval "\$in{given$i};";
			$given =~ s/\"/\&quot;/g;

			my $CIgiven = $given;
		 	#$CIgiven =~ tr/A-Z/a-z/;
			$CIgiven =~ s/\0//g;
		 	$CIgiven =~ s/\s//g;

			$given =~ s/\0/:_:/g;

			my $SaveGiven = $given;
			&AddToTotals;		
			$given = $SaveGiven;

			if ( ( lc($answer) ne lc($CIgiven) ) && ($answer) )
			 {
			 	undef $status;
			 	$IncorrectQuestions .= "$i ";
			 }
			$inanswers .= "$given|";


		 }
		chop $inanswers;
	 }
	 
	if ($status eq 'C')  { $correctentries++; }
		
 	&AddEntry;
 	
 	&SetCookies;

 	if ( ($in{notify}) && ($in{Email}) )
 	 {
 		&AddNotify;
 	 }

	&SendEmails;
	
	&PrintResult;
 }

################################################
# Show rules
################################################

sub ShowRules
 {
	require "$contest_dir/$in{filename}.vars.$cgiext";

	&header;
	$htmloutput .= qq~
		<h4>$translate14:</h4>
		$rules
	~;
	&footer;
 }


######################################################################
# check required
######################################################################

sub CheckEntryRequired {

	my $save_rules = $rules;
	my $save_rules_url = $rules_url;
	&SetRulesLocation;
	$rules = $save_rules;
	$rules_url = $save_rules_url;

	if ($in{Email}) { &CheckEmail; }
	
	foreach $Use_Pair (@USE_PAIRS)
	 {
		&SplitUsePairs;
		my $Use_Required = eval "\$Req_$UsePairName;";

		if ( (!$in{$UsePairName}) && ($Use_Required) )
		 {
			$missingfields .= "$UsePairTranslate<br>";
		 }
	 }
	
	if ($no_questions > 0)
	 {
		for ($i = 1; $i <= $no_questions; $i++)
		 {
			my $Required = eval "\$QRequired$i;";
			my $Given = eval "\$in{given$i};";
			if ( ($Required eq 'checked') && (!$Given) )
			 {
				$missingfields .= "$translate77 $i<br>";
			 }
		 }
	 }

	if ( (!$in{RulesAgreed}) and (($rules_url) or ($rules)) )

	 {
	 	$missingfields .= "$translate13 $rulesoutput.<br>";
	 }
	if ($missingfields)
	 {
		&PrintMessage(
			"$translate1",
			"<p>$translate16</p>
			<blockquote><b>$missingfields</b></blockquote>
			<p>$translate17</p>",
			"1",
			""
			);
	 }
}

######################################################################
# sub to add to correct database
######################################################################

sub AddEntry
 {


	$in{Comments} =~ s/\cM\n/<br>/g;

	my $InUsePairs;
	
	foreach $Use_Pair (@USE_PAIRS)
	 {
		&SplitUsePairs;
		my $InUsePairName = eval "\$in{$UsePairName};";
		if ($InUsePairName =~ /^\s*http:\/\/\s*$/i) { undef $InUsePairName; }
		$InUsePairs .= "$InUsePairName|";
	 }
	chop $InUsePairs;
	
	open (FILE,">>$contest_dir/$in{filename}.$cgiext");
	if (!$DisableFlock) { flock(FILE,2); }
	print FILE "$html_TotalEntries|$CurrentEntryFormat|$status|$today_julian_day|$ENV{'REMOTE_HOST'}|$InUsePairs|$inanswers\n";
	if (!$DisableFlock) { flock(FILE,8); }
	close(FILE);

	chmod (0666, "$contest_dir/$in{filename}.$cgiext");

 }


################################################
# Check for dup and add to pre non-elibigble list
################################################

sub CheckDup {

	my @entries;
	
	if (-e "$contest_dir/$in{filename}.$cgiext")
	 {
		@entries = &OpenFileArray(
			"$contest_dir/$in{filename}.$cgiext",
			"While attempting to open entries to check for duplicate entry."
			);

		chop @entries;
	 }
	$html_TotalEntries = @entries;
	$html_TotalEntries++;
	$correctentries;

	foreach $entry (@entries)
	 {    
		&splitentry;
		if ($entryduration eq 'single')
		 {
			if ( ($uip eq $ENV{'REMOTE_HOST'}) && ($checkdupenv))
			 { &AreadyEntered; }
	
		 }
		elsif ($entryduration eq 'daily')
		 {
			if ( ($uip eq $ENV{'REMOTE_HOST'}) && ($udate eq $today_julian_day) && ($checkdupenv) )
			 { &AreadyEnteredToday; }
	
		 }

		if ($ustatus eq 'C') { $correctentries++; }
	 }
 }

################################################
# Already Entered Message
################################################

sub AreadyEntered
 {
	if ($already_url)
	 {
		print "Location: $already_url\n\n";
		exit;
	 }		

 	&PrintMessage(
		"$translate1", 
		"$translate18 $SubmissionType.",
		"1",
		""
		);
 }

################################################
# Already Entered Message
################################################

sub AreadyEnteredToday
 {
	if ($already_url)
	 {
		print "Location: $already_url\n\n";
		exit;
	 }		

 	&PrintMessage(
		"$translate1", 
		"$translate19",
		"1",
		""
		);

 }

################################################
# Print result on add/remove notify and no download
################################################

sub PrintResult
 {

	$CorrectRedirURL = $redirect_url if !$CorrectRedirURL;
	$IncorrectRedirURL = $redirect_url if !$IncorrectRedirURL;

	if ( ($CorrectRedirURL) && ($status eq 'C') )
	 {
		print "Location: $CorrectRedirURL\n\n";
		exit;
	 }
	elsif ( ($IncorrectRedirURL) && ($status ne 'C') )
	 {
		print "Location: $IncorrectRedirURL\n\n";
		exit;
	 }
	
	if (!$correctentries) { $correctentries = 0; }
	
	&header;
	
	### Your submissions was ...
 	$htmloutput .= qq~
		<p><b>$translate23</b></p>
		<p>$translate25 <b>$html_TotalEntries</b>.
	~;
	
	### If lucky winner ...
	if ( ($SubmissionType eq 'Contest') && ( (!$correctonly) or ( ($correctonly) && ($status eq 'C') ) ) )
	{
		$htmloutput .= qq~
			$translate26</p>
		~;
	}

	### Notify if correct
	if ( ($no_questions > 0) && ($showcorrect) && ($status eq 'C') ) 
	 {
		$htmloutput .= qq~
			<p>$translate24</p>
		~;
	 }

	### Inform of the incorrect questions
	if ( ($no_questions > 0) && ($ShowIncorrect) && ($status ne 'C') ) 
	 {
		$htmloutput .= qq~
			<p>$translate76 $IncorrectQuestions</p>
		~;
	 }

	$htmloutput .= qq~
		<p>$translate27</p>
		<blockquote>
		<p>
		<strong>
	~;

	foreach $Use_Pair (@USE_PAIRS)
	 {
		&SplitUsePairs;
		if ($in{$UsePairName}) { $htmloutput .= "$in{$UsePairName}<br>"; }
	 }
	
	$htmloutput .= qq~
		</strong>
		</p>
	~;

	if ($no_questions > 0)
	 {
		$htmloutput .= "<p>";
		for ($i = 1; $i <= $no_questions; $i++)
		 {
			my $question = eval "\$question$i;";
			my $given = eval "\$in{given$i};";
			$given =~ s/\0/\//g;

			$htmloutput .= qq~
				<p>
				<strong>$question</strong><br>
				<i>$given</i>
				</p>
			~;
		 }
		$htmloutput .= "</p>";
	 }

	$htmloutput .= qq~
		</blockquote>
	~;

	if ( ($ShowTotals) && ($no_questions > 0) )
	 { 
	 	$NoTotalHeader = 1;
	 	&ShowTotals;
	 	
	 }

	if ($contest_email)
	 {
	 	$htmloutput .= qq~
			<p>$translate28 <a href="mailto:$contest_email">$contest_email</a>.
		~;
	 }
	
	$htmloutput .= qq~
		<p>$translate29</p>
	~;

	&footer;
 }


################################################
# Check to see if banned
################################################

sub CheckBanned {

	if (-e "$contest_dir/$in{filename}.ban.$cgiext")
	 {

		my @isbanned = &OpenFileArray(
			"$contest_dir/$in{filename}.ban.$cgiext",
			"While attempting to open ban list.."
			);
		
		foreach $isbanned (@isbanned)
		 {
			chop($isbanned) if $isbanned =~ /\n$/;
			if ( ($isbanned) && (($isbanned eq $in{Email}) or ($isbanned eq $StrippedPhone) or ($isbanned eq $ENV{'REMOTE_HOST'})) )
			 {
			 	&PrintMessage(
					"$translate1",
					"$translate30",
					"1",
					""
				);
			 }
		 }
	 }
}

###################################################################################
# Add notify
###################################################################################

sub AddNotify
 {
	my $notifyalready;

	if (!-e "$contest_dir/notify.$cgiext")
	 {
		open (FILE,">>$contest_dir/notify.$cgiext");
		close(FILE);
	 }
	 
	my @notify = &OpenFileArray(
		"$contest_dir/notify.$cgiext",
		"While attempting to add to notify list."
		);

	foreach $notify (@notify)
	 {    
		&SplitNotify;
		if ($notifyemail =~ /^\s*$in{Email}\s*$/i)
		 {
			$notifyalready=1;
			last;
		 }
	 }

	if (!$notifyalready)
	{ 
		open (FILE,">>$contest_dir/notify.$cgiext") || die "Can't open notify.$cgiext!\n";
		if (!$DisableFlock) { flock(FILE,2); }
		print FILE "$in{Name}|$in{Email}\n";
		if (!$DisableFlock) { flock(FILE,8); }
		close(FILE);
	}
 }

###################################################################################
# Set for Random Choices
###################################################################################

sub SetRandom
 {
	@newchoices=();
	@allchoices=();
	if ($answer)
	 {
	 	push (@allchoices, $answer);
	 }
	@otherchoices = split(/\|/, $choices);
	push (@allchoices, @otherchoices);
	if ($randomchoices)
	 {
	 	srand;
		while (@allchoices)
	 	{
			push(@newchoices, splice(@allchoices, rand @allchoices, 1));
		 }
	 }
	else
	 {
		push (@newchoices, @allchoices);
	 }
	undef $randomchoices;
 }
  
###################################################################################
# Create form for entry
###################################################################################

sub entryform
 {
	$EntryFormView = 1;
	
	&SetUsePairs;
	
	$cookie{cAddress} =~ s/<br>/\n/g;

	if (!-e "$contest_dir/$in{filename}.vars.$cgiext")
	 {
	 	&PrintMessage(
			"$translate1",
			"File not found.",
			"1",
			""
		);
	 }

	require "$contest_dir/$in{filename}.vars.$cgiext";

	&Set_Pre_V29;
	&CheckContestStatus;
	&PrintContestStatus;
	
	undef $isreq;
	undef $isreqor;

	my $req_sym = "*";

	&header;

	&SetRulesLocation;
	

	$html_Header .= qq~
		$EntryFormHeader
		<p><font size="1">
		$translate33
		</font></p>
	~;
	
	if ( ($ShowTotals) && ($no_questions > 0) )
	 {
		$html_Header .= qq~
			<font size="$fontsize" face="$fontface">
			<p><a href="$subs3script?action=ShowTotals$GlobalQueryString">
			$translate34</a></p>
			</font>
			
		~;
	 }

	$html_Header .= qq~
		<form method="POST" action="$giveawayscript" name="EntryForm">
		<input type="hidden" name="action" value="SubmitEntry">
		<input type="hidden" name="contest_email" value="$contest_email">
		<input type="hidden" name="filename" value="$filename">
		<input type="hidden" name="id" value="$in{id}">
		<input type="hidden" name="password" value="$in{password}">
		<input type="hidden" name="View" value="$in{View}">
		<input type="hidden" name="type" value="$in{type}">
		<input type="hidden" name="language" value="$in{language}">
	~;
			
	my ($RequiredNeeded, $NotifyFlag, $DemoUsed);
	
	foreach $Use_Pair (@USE_PAIRS)
	 {
		&SplitUsePairs;
		my $Use_Checked = eval "\$Use_$UsePairName;";
		my $Use_Cookie = eval "\$cookie{$UsePairName};";
		my $Use_Required = eval "\$Req_$UsePairName;";
		
		if ($Use_Checked)
		 { $DemoUsed = 1; last; }
		 
	 }

	if ($DemoUsed)
	  {
	  	$html_FormFields = qq~
			  <table border="0" cellspacing="2" cellpadding="3">
		~;
	
		foreach $Use_Pair (@USE_PAIRS)
		 {
			&SplitUsePairs;
			
			my $Use_Checked = eval "\$Use_$UsePairName;";
			my $Use_Required = eval "\$Req_$UsePairName;";
			my $Use_Cookie = eval "\$cookie{$UsePairName};";

			if ( ($Use_Checked) && ($UsePairName eq 'Email') )
			 {
			 	$NotifyFlag = 1;
			 }
	
			if ($Use_Required)
			 {
			 	$RequiredNeeded = 1;
			 }
			
			if (!$UsePairSetCookie) { undef $Use_Cookie; }
	
			if (!$Use_Cookie) { $Use_Cookie = $UsePairDefaultValue; }
			if ($Use_Required) { $Use_Required = $req_sym; }
	
			$UsePairNameLC = $UsePairName;
			$UsePairNameLC =~ tr/Z-A/z-a/;
			
			#my $Use_Translate = $UsePairTranslate;
			
			if ( ($Use_Checked) && ($UsePairType eq 'text') )
			 {
				$html_FormFields .= qq~
				    <tr>
			      		<td valign="top" $tablebgcolor1tag align="right">
					<font color="$fontcolor" size="$fontsize" face="$fontface">
					$UsePairTranslate:
					</font>
					</td>
				      <td valign="top" $tablebgcolor2tag>
					<input type="text" name="$UsePairNameLC" size="$UsePairLength" value="$Use_Cookie">
					</td>
				      <td valign="top" align="left">
				     $Use_Required
				     </td>
				    </tr>
				~;
			 }
			elsif ( ($Use_Checked) && ($UsePairType eq 'textarea') )
			 {
				$html_FormFields .= qq~
				    <tr>
			      		<td valign="top" $tablebgcolor1tag align="right">
					<font color="$fontcolor" size="$fontsize" face="$fontface">
					$UsePairTranslate:
					</font>
					</td>
				      <td valign="top" $tablebgcolor2tag>
					<textarea rows="2" name="$UsePairNameLC" cols="$UsePairLength">$Use_Cookie</textarea>
					</td>
				      <td valign="top" align="left">
				     $Use_Required
				     </td>
				    </tr>
				~;
			 }
		
		 }
	
		$html_FormFields .= qq~
			  </table>
		~;
		
		$htmloutput .= $html_FormFields;
	 }
	 
	if ($no_questions > 0)
	 {

		if (!$HintImage)
		 {
			$HintImage = "$image_dir/hint.gif";
		 }			

		$html_Questions = qq~
			<table border="0" cellspacing="2" cellpadding="3" width="$qtablewidth">
		~;

		my ($HintNoteNeeded);
		
		for ($i = 1; $i <= $no_questions; $i++)
		 {
			my ($hintlink);
			
			$answer = eval "\$answer$i;";
			$choices = eval "\$choice$i;";
			$randomchoices = eval "\$randomchoices$i;";

			my $question = eval "\$question$i;";
			my $link = eval "\$link$i;";
			my $type = eval "\$type$i;"