#!/usr/bin/perl

#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

eval {

  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "Date.pl";
require "mods.file";
require "mail-lib.pl";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";
};

if ($@) {
    print ("Content-type: text/html\n\n");
    print "Error including required files: $@\n";
    print "Make sure these files exist, permissions are set properly, and paths are set correctly.";
 exit;
}

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name eq "forum") {
		$Forum = $Value;
		$Forum =~ s/\/\\//g;
		$ForumCoded = &HTMLIFY($Forum);
		$ForumCoded =~ tr/ /+/;
		$Forum = &UNHTMLIFY($Forum);
	}
	if ($Name eq "TopicSubject") {
		$TopicSubject = $Value;
		$TopicSubject =~ s/<.+?>//g;
		$TopicSubject =~ s/</\&lt\;/g;
		$TopicSubject = &UNHTMLIFY($TopicSubject);
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserName = &UNHTMLIFY($UserName);
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "PasswordConfirm") {
		$PasswordConfirm = $Value;
	}

	if ($Name eq "number") {
		$number = $Value;
		$number =~ s/\D//sg;
	}
	if ($Name eq "topic") {
		$topic = $Value;
	}
	if ($Name eq "Email") {
		$Email = $Value;
		$Email =~tr/A-Z/a-z/; 
	}
	if ($Name eq "URL") {
		$URL = &CleanThis($Value);
		$URL = &PipeCleaner($URL);
	}
	if ($Name eq "Occupation") {
		$Occupation = &CleanThis($Value);
		$Occupation = &PipeCleaner($Occupation);
	}
	if ($Name eq "Location") {
		$Location = &CleanThis($Value);
		$Location = &PipeCleaner($Location);
	}
	if ($Name eq "TotalPosts") {
		$TotalPosts = $Value;
	}
	if ($Name eq "Interests") {
		$Interests = &CleanThis($Value);
		$Interests = &PipeCleaner($Value);
	}
}  # end FOREACH $row

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

# if necessary set Random Number - for use in Banner Ads, etc.
if ( ($Header ne "") || ($Footer ne "") ) {

$RandomNumber = &MakeRandomNumber;
$RandomNumber2 = $RandomNumber + 100074;

 if ($Header ne "") {
   $Header =~ s/UBBrandomX/$RandomNumber/isg;
   $Header =~ s/UBBrandomY/$RandomNumber2/isg;
 }
 if ($Footer ne "") {
   $Footer =~ s/UBBrandomX/$RandomNumber/isg;
   $Footer =~ s/UBBrandomY/$RandomNumber2/isg;
 }

} # end if header or footer

#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

if ($BBStatus eq "OFF") {
print ("Content-type: text/html\n\n");
&StandardHTML($BBClosedMessage);
exit;
}

$ReplyMessage = $in{'ReplyMessage'};
$Message = $in{'Message'};

$SubjectCoded = &HTMLIFY($TopicSubject);
$SubjectCoded =~ tr/ /+/;

print ("Content-type: text/html\n\n");

if ($in{'action'} eq "addfav") {&AddFav;} 
if ($in{'action'} eq "delfav") {&DelFav;} 
if ($in{'action'} eq "updatefavs") {&UpdateFavs;} 
if ($in{'action'} eq "setfavs") {&SetFavs;} 
if ($in{'action'} eq "admin") {&Admin;} 
if ($in{'action'} eq "updateadmin") {&UpdateAdmin;} 

######################################################################

sub AddFav{
&get_cookie;  #retrieves all current cookies
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
}  else {
	$ExtraInfo = "";
}

$id = $in{'id'};
$fav = $cookie{Fav};
@fav = split(/\-/,$fav);
push @fav,$id;
$fav = join("\-",@fav);

print<<CONFIRMHTML;
<HTML><HEAD>
<meta http-equiv="Refresh" content="1; URL=$CGIURL/Ultimate.cgi?action=intro&showall=1">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!--HIDE

expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}
 
var FavString = escape("$fav");

document.cookie = "Fav=" + FavString + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace">
<B>This forum has been added to your favourites.  You are being automatically transported to the bulletin board introductory page.  Please wait a second.
<P>
<BR><BR>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&showall=1">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
CONFIRMHTML

}#end

######################################################################

sub DelFav{
&get_cookie;  #retrieves all current cookies
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
}  else {
	$ExtraInfo = "";
}

$id = $in{'id'};
$fav = $cookie{Fav};
@fav = split(/\-/,$fav);
undef @newfav;
foreach (@fav){if ($id != $_){push @newfav,$_}}
$fav = join("\-",@newfav);

print<<CONFIRMHTML;
<HTML><HEAD>
<meta http-equiv="Refresh" content="1; URL=$CGIURL/Ultimate.cgi?action=intro&showall=1">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!--HIDE

expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}
 
var FavString = escape("$fav");

document.cookie = "Fav=" + FavString + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace">
<B>This forum has been removed from your favourites.  You are being automatically transported to the bulletin board introductory page.  Please wait a second.
<P>
<BR><BR>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&showall=1">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
CONFIRMHTML

}#end

######################################################################

sub UpdateFavs{
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);}else{$ExtraInfo = "";}

##see what our new favourites are...
@forums = &OpenFile("$VariablesPath/forums.cgi");
$numforums = scalar @forums;
undef @newfav;
for($i=1;$i<=$numforums;$i++){if ($in{"fav$i"} ne "") {push @newfav,$i;}}
$fav = join("\-",@newfav);

print<<CONFIRMHTML;
<HTML><HEAD>
<meta http-equiv="Refresh" content="1; URL=$CGIURL/Ultimate.cgi?action=intro&showall=1">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!--HIDE

expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}
 
var FavString = escape("$fav");

document.cookie = "Fav=" + FavString + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Your favourites have been updated.  You are being automatically transported to the bulletin board introductory page.  Please wait a second.
<P>
<BR><BR>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&showall=1">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
CONFIRMHTML

}#end

######################################################################

sub SetFavs{

print <<OUT;
<html>
<head>
<title>$BBName Favourites</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<body bgcolor="#FFFFFF" >
<table width="$TableWidth" border="0" cellspacing="1" cellpadding="3" align=center>
  <tr > 
    <td > 
      <A HREF="$CGIURL/Ultimate.cgi?action=intro&bypasscookie=true"><IMG SRC=$NonCGIURL/$BBTitle border=0></a>
      <td align=center><h4> <font face="$FontFace" color="$LinkColor">$BBName Favourites</font></h4>
    </td>
  </tr>
</table>
  
<table width="$TableWidth" border="0" cellspacing="1" cellpadding="3" align=center>
<form method=post action="$CGIURL/favs.cgi?">
<input type="hidden" name="action" value="updatefavs">
    <tr $TableColorStrip> 
    <td colspan="4"> 
      <font face="$FontFace" size="2" color="$TableStripTextColor"><h5>&nbsp;Favourite Forums</h5></font>
    </td>
  </tr>
OUT

&get_cookie;  #retrieves all current cookies
$fav = $cookie{Fav};
@fav = split(/\-/,$fav);

require "fav.setup";
@perms = split(/\-/,$fav_perms);

##should we be doing it by category?
if ($CategoryView eq "yes"){

@CATEGORIES = &OpenFile("$NonCGIPath/categories.file");
@CATEGORIES = sort @CATEGORIES;

@forums = &OpenFile("$VariablesPath/forums.cgi");

$one = 1;

foreach $cat(@CATEGORIES){

chomp $cat;
@catinfo = split(/\|\|\|/,$cat);

##print cat header
print qq(
    <tr $CategoryStripColor> 
    <td colspan="4"> 
      <font face="$FontFace" size="2" color="$CategoryStripTextColor"><h5>&nbsp;$catinfo[1]</font>
    </td>
  </tr>
);

foreach (@forums){
@foruminfo = split(/\|/,$_);
if (($foruminfo[0] == $catinfo[2]) && ($foruminfo[3] eq "On")){
$okay = 1;
foreach $perm(@perms){if ($perm == $foruminfo[8]){$okay=0;}}

$check="";
foreach $f(@fav){if ($f==$foruminfo[8]){$check=" checked"}}

if ($one){if ($col eq $AltColumnColor1){$col=$AltColumnColor2;}else{$col=$AltColumnColor1;}}
$line = qq(<input type="checkbox" name="fav$foruminfo[8]"$check>);

if ($okay == 0){$line = "<font color=\"#ff0000\">Always Show";}

if ($one){print "<tr $col>";}
print qq(<td align=right width=100><font face="$FontFace" size="2">$line</td>);
print qq(<td align=left><font face="$FontFace" size="2">$foruminfo[1]</font></td>);
if (!$one){print "<\/tr>";}

$one = !($one);
}}
if (!$one){print "<td>&nbsp;</td><td>&nbsp;</td></tr>";}

if ($col eq $AltColumnColor1){$col=$AltColumnColor2;}else{$col=$AltColumnColor1;}

}  
} else {

@forums = &OpenFile("$VariablesPath/forums.cgi");

$one = 1;

foreach (@forums){
@foruminfo = split(/\|/,$_);
if ($foruminfo[3] eq "On"){
$okay = 1;
foreach $perm(@perms){if ($perm == $foruminfo[8]){$okay=0;}}

$check="";
foreach $f(@fav){if ($f==$foruminfo[8]){$check=" checked"}}

if ($one){if ($col eq $AltColumnColor1){$col=$AltColumnColor2;}else{$col=$AltColumnColor1;}}
$line = qq(<input type="checkbox" name="fav$foruminfo[8]"$check>);

if ($okay == 0){$line = "<font color=\"#ff0000\">Always Show";}

if ($one){print "<tr $col>";}
print qq(<td align=right width=100><font face="$FontFace" size="2">$line</td>);
print qq(<td align=left><font face="$FontFace" size="2">$foruminfo[1]</font></td>);
if (!$one){print "<\/tr>";}

$one = !($one);
}}
if (!$one){print "<td>&nbsp;</td><td>&nbsp;</td></tr>";}

if ($col eq $AltColumnColor1){$col=$AltColumnColor2;}else{$col=$AltColumnColor1;}

}

print<<OUT;
  <tr $col> 
    <td align=center colspan=4><input type="submit" value="Set Favourites"></td>
  </tr>
</form>
</table>

<center><p><B><FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL" target=_top>$MyHomePage</A>
</B></FONT>
<P>
<FONT COLOR="$CopyrightTextColor" size="1" FACE="$FontFace">$YourCopyrightNotice
<P>
$infopopcopy<br>
Ultimate Bulletin Board $Version
<br><br>
</FONT>
</CENTER></font>
</p>
</body>
</html>
OUT

}#end

######################################################################

sub Admin{

require "fav.setup";

$ACheck[$fav_mode_ultimate] = " checked";
$BCheck[$fav_show_favs] = " checked";
$CCheck[$fav_favpage_ultimate] = " checked";
$DCheck[$fav_favpage_forumdisplay] = " checked";
$ECheck[$fav_addlink_forumdisplay] = " checked";
$FCheck[$fav_img_ultimate] = " checked";

print<<OUT;

<table width="$TableWidth" border="0" cellspacing="1" cellpadding="3" align=center>
  <tr > 
    <td > 
      <A HREF="$CGIURL/Ultimate.cgi?action=intro&bypasscookie=true"><IMG SRC=$NonCGIURL/$BBTitle border=0></a>
      <td align=center><h4> <font face="$FontFace" color="$LinkColor">Favourites Settings</font></h4>
    </td>
  </tr>
</table>

<form method="post" action="$CGIURL/favs.cgi?">
<input type="hidden" name="action" value="updateadmin">

<center>
<table cellpadding=0 cellspacing=0 border=0 width="$TableWidth" bgcolor="#000000"><tr><td>
<table cellpadding=4 cellspacing=1 border=0 width="100%">

<tr bgcolor="#000000">
	<td colspan=2><font face="$FontFace" size=2 color="#ffff00">
		<b>Ultimate.cgi</b>
	</td>
</tr>
<tr bgcolor="#ffffcc">
	<td colspan=2><font face="$FontFace" size=2>
		Settings that affect the favourites appearance in Ultimate.cgi
	</td>
</tr>

<tr bgcolor="#dedfdf">
	<td><font face="$FontFace" size=2>
		<b>Favourites Links in Ultimate.cgi</b><br>
		This setting determines how the user can choose favoutites forums from Ultimate.cgi. The 'Standard' option gives each forum a link, the 'Box' option puts a checkbox next to each forum (when viewing all), allowing the user to update all settings at once. If you select 'None', no links for choosing favourites are shown on the main page.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_mode_ultimate" value="1"$ACheck[1]>Standard<br>
		<input type="radio" name="fav_mode_ultimate" value="2"$ACheck[2]>Box<br>
		<input type="radio" name="fav_mode_ultimate" value="3"$ACheck[3]>None<br>
	</td>
</tr>

<tr bgcolor="#f7f7f7">
	<td><font face="$FontFace" size=2>
		<b>Favourite Forum Markers</b><br>
		Changing this setting to on will display a small icon unser the lightbulb icon in each favourite forum, whilst in view all forums mode.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_show_favs" value="1"$BCheck[1]>On<br>
		<input type="radio" name="fav_show_favs" value="0"$BCheck[0]>Off<br>
	</td>
</tr>

<tr bgcolor="#dedfdf">
	<td><font face="$FontFace" size=2>
		<b>Favourite Settings Page Link</b><br>
		Changing this setting to on will add a link to Ultimate.cgi which allows the editing and reviewing af all favourites settings.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_favpage_ultimate" value="1"$CCheck[1]>On<br>
		<input type="radio" name="fav_favpage_ultimate" value="0"$CCheck[0]>Off<br>
	</td>
</tr>

<tr bgcolor="#dedfdf">
	<td><font face="$FontFace" size=2>
		<b>Favourites Icons</b><br>
		Changing this setting to on will show images for favourites links in Ultimate.cgi, instead of text labels.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_img_ultimate" value="1"$FCheck[1]>On<br>
		<input type="radio" name="fav_img_ultimate" value="0"$FCheck[0]>Off<br>
	</td>
</tr>

<tr bgcolor="#000000">
	<td colspan=2><font face="$FontFace" size=2 color="#ffff00">
		<b>Forumdisplay.cgi</b>
	</td>
</tr>
<tr bgcolor="#ffffcc">
	<td colspan=2><font face="$FontFace" size=2>
		Settings that affect the favourites appearance in Forumdisplay.cgi
	</td>
</tr>

<tr bgcolor="#dedfdf">
	<td><font face="$FontFace" size=2>
		<b>Add/Remove Links</b><br>
		Changing this setting to on will put add or remove links at the the top of the forumdisplay.cgi page.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_addlink_forumdisplay" value="1"$ECheck[1]>On<br>
		<input type="radio" name="fav_addlink_forumdisplay" value="0"$ECheck[0]>Off<br>
	</td>
</tr>
<tr bgcolor="#f7f7f7">
	<td><font face="$FontFace" size=2>
		<b>Favourite Settings Page Link</b><br>
		Changing this setting to on will add a link to forumdisplay.cgi which allows the editing and reviewing af all favourites settings.
	</td>
	<td><font face="$FontFace" size=2>
		<input type="radio" name="fav_favpage_forumdisplay" value="1"$DCheck[1]>On<br>
		<input type="radio" name="fav_favpage_forumdisplay" value="0"$DCheck[0]>Off<br>
	</td>
</tr>


<tr bgcolor="#000000">
	<td colspan=2><font face="$FontFace" size=2 color="#ffff00">
		<b>Permanent Fourms</b>
	</td>
</tr>
<tr bgcolor="#ffffcc">
	<td colspan=2><font face="$FontFace" size=2>
		Settings to make selected forums always appear in the favourites view
	</td>
</tr>
OUT


$col = "#dedfdf";

@perms = split(/-/,$fav_perms);

@forums = &OpenFile("$VariablesPath/forums.cgi");

foreach(@forums){
@foruminfo = split(/\|/,$_);

$Check="";
foreach $perm(@perms){if ($perm == $foruminfo[8]){$Check = " checked";}}

print qq(
<tr bgcolor="$col">
	<td><font face="$FontFace" size=2>
		<b>Forum $foruminfo[8]</b><br>
		Always show &quot;$foruminfo[1]&quot;?
	</td>
	<td><font face="$FontFace" size=2>
		<input type="checkbox" name="fav_perm_$foruminfo[8]"$Check>Permanent<br>
	</td>
</tr>);
if ($col eq "#dedfdf"){$col = "#f7f7f7";}else{$col = "#dedfdf";}
}

print <<OUT;
</table>
</td></tr></table>

<P>
<FONT SIZE="1" FACE="Verdana, Arial">
$DiagnosticWording</FONT></B>
<P>
<br>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Enter your UserName & Password:</font>
<P>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
UserName: <INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Password <INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></FONT></B></CENTER>
<p><center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Favourites Settings Now"></center>

</form>
<br>
<center>
<font face="$FontFace" size="1">A hack by cal - &copy;2000</font><br>
<br>
OUT

}#end

######################################################################

sub UpdateAdmin{

### CHECK USERNAME - must be an admin
##verify that this user is an administrator
$okay=0;
#check to see which Member Format is in place, process accordingly
if (-e "$MembersPath/memberslist.cgi") {
	$ProfileNumber = &GetUserNumber($in{'UserNameCheck'});
	if ($ProfileNumber ne "") {$NameFound = "yes";} else {$NameFound = "no";}
}else{
	$ProfileNumber = $UserNameCheckFile;
	$NameFound = "no";
	if (-e "$MembersPath/$ProfileNumber.cgi") {$NameFound = "yes";} 
}

if ($NameFound eq "yes") {
	@profilestats = &OpenProfile("$ProfileNumber.cgi");
	chomp($profilestats[1]);
	if ($in{'PasswordCheck'} eq "$profilestats[1]") {
		$Permission = "$profilestats[4]";
		chomp($Permission);
		&CheckPermissions;
	  	if ($AdminPermission eq "true") {$okay=1;}
	}
}
if ($okay==0) {&StandardHTMLCP("Invalid Login"); exit;}

@forums = &OpenFile("$VariablesPath/forums.cgi");
foreach(@forums){
	@foruminfo = split(/\|/,$_);
	if ($in{"fav_perm_$foruminfo[8]"} ne "") {push @perms,$foruminfo[8];}
}
$fav_perms = join("-",@perms);

open (FILE, ">$VariablesPath/fav.setup");
print FILE "\$fav_mode_ultimate = $in{'fav_mode_ultimate'};\n";
print FILE "\$fav_show_favs = $in{'fav_show_favs'};\n";
print FILE "\$fav_favpage_ultimate = $in{'fav_favpage_ultimate'};\n";
print FILE "\$fav_favpage_forumdisplay = $in{'fav_favpage_forumdisplay'};\n";
print FILE "\$fav_addlink_forumdisplay = $in{'fav_addlink_forumdisplay'};\n";
print FILE "\$fav_perms = \"$fav_perms\";\n";
print FILE "\$fav_img_ultimate = $in{'fav_img_ultimate'};\n";
print FILE "1;\n";
close(FILE);

print<<OUT;
<HTML><HEAD>
<meta http-equiv="Refresh" content="1; URL=$CGIURL/favs.cgi?action=admin">
$HeaderInsert
</HEAD>
<BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Your settings have been updated.  You are being automatically transported to the favourites admin page.  Please wait a second.
<P>
<BR><BR>
<A HREF="$CGIURL/favs.cgi?action=admin">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
OUT


}#end

######################################################################

exit(0); # comply with SafePerl
