#!/usr/local/bin/perl

####################################################################
#
#	Script Title:	Change Username
#	Written By:	Andy Tomaka{atom911} atom_911@hotmail.com
#	Last Modifies:	May 07, 2000
#
####################################################################
# Parse the URL to check for the action
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\n/ /g;	# replace newlines with spaces
	$FORM{$name} = $value;
}


# Allows the script to work with HTML
print ("content-type:text/html\n\n");

# Substitute all require files here for the file
require "UltBB.setup";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";


$BGColor = qq~bgcolor="$BGColor"~;
$PageBackground = qq~background="$PageBackground"~;

# Decide what to do
if ($FORM{'action'} eq "usernamelogin") {
	&usernamelogin;
	exit;
} elsif ($FORM{'action'} eq "usernamelogincheck") {
	&usernamelogincheck;
	exit;
} elsif ($FORM{'action'} eq "usernameformhtml") {
	&usernameformhtml;
	exit;
} elsif ($FORM{'action'} eq "usernamechange") {
	&usernamechange;
	exit;
} else {
	&usernamelogin;
	exit;
}

###############################################################
# The subroutine that handles logging in
###############################################################
sub usernamelogin {
	print qq~
<HTML>
<HEAD><TITLE>$BBName - Change UserName</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="2" FACE="$FontFace" COLOR="$TextColor">
$Header
</font>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
<FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor"><B>Change UserName</B></FONT>
<p>
<FONT SIZE="$TextSize" FACE="$FontFace">
You can now modify your username!  To modify your username, please login to the script that allows you to change your username.

<p>
<form method="post">
<INPUT TYPE="hidden" NAME="action" VALUE="usernamelogincheck">
<table border=0>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>UserName</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td></tr>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Password</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;<FONT SIZE="1" FACE="$FontFace"><A HREF="$CGIURL/Ultimate.cgi?action=lostpw">Forget your password?</A></font>
</td></tr>
</table>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Identification">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Clear Fields">
</center>
</form>
<P>
If you have previously registered, but forgotten your password, <A HREF="$CGIURL/Ultimate.cgi?action=lostpw">click here</A>.
<P>
$Footer
</FONT>
</BODY></HTML>
	~;
}


###############################################################
# The Subroutine that checks the ID
###############################################################
sub usernamelogincheck {
$UserName = $FORM{'UserName'};
$Password = $FORM{'Password'};

	unless (-e "$MembersPath/emailfile.cgi") {
		&StandardHTML("We are upgrading our software at the moment and cannot process new registrations.  Please try registering again in a little while.  Thank you!");
	exit;
	}

	if (-e "$MembersPath/temp.file") {
		&StandardHTML("We are temporarily upgrading our Memberships.  This process only takes a minute or two.  Please try registering again in a couple of minutes.  Thank you!");
		exit;
	}
	if (-e "$CGIPath/temp.file") {
		&StandardHTML("We are temporarily upgrading our Memberships.  This process only takes a minute or two.  Please try registering again in a couple of minutes.  Thank you!");
		exit;
	}
	
	if (($UserName eq "")||($Password eq "")) {
		&StandardHTML("You did not complete all required form fields!  Please go back and re-enter.");
	} else {
		$NameFound = "no";

		$ProfileNumber = &GetUserNumber($UserName);
		if ($ProfileNumber ne "") {
			$NameFound = "yes";
		} else {
			$NameFound = "no";
		}

		if ($NameFound eq "yes") {
			#Check Password Now
		
			@profile = &OpenProfile("$ProfileNumber.cgi");
			if ($Password eq "$profile[1]") {
				$pwmatch = "true";
				&usernameformhtml;
			}
		}

		if ($NameFound ne "yes") {
			&StandardHTML("We have no one registered with that user name.  Use your back button to try again.");
		}
		if (($NameFound eq "yes") && ($pwmatch ne "true")) {
			&StandardHTML("Sorry, but the password you entered was not correct.  Please try again. Use your Back button.");
		}
	} # end check for missing fields
}

###############################################################
# The subroutine that prints the form
###############################################################
sub usernameformhtml {
	# Print the form HTML
	print qq~
<HTML>
<HEAD><TITLE>Change Your UserName</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="2" FACE="$FontFace" COLOR="$TextColor">
$Header
</font>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
<FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor"><B>Change UserName</B></FONT>
<p>
<FONT SIZE="$TextSize" FACE="$FontFace">
Input your new username.  This new username must follow all rules defined for usernameswhen you registered.

<p>
<form method="post">
<INPUT TYPE="hidden" NAME="action" VALUE="usernamechange">
<INPUT TYPE="hidden" NAME="oldusername" VALUE="$UserName">
<table border=0>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Current UserName</B></FONT>
</td>
<td>
$profile[0]
</td></tr>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">New UserName</FONT></B>
</td>
<td>
<input type="text" name="newusername" size="30">
</td></tr>
</table>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit New UserName">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Restart">
</center>
</form>
<P>
$Footer
</FONT>
</BODY></HTML>
	~;
}

###############################################################
# Subroutine that handles the changes
###############################################################
sub usernamechange {
	$OldUserName = $FORM{'oldusername'};
	$NewUserName = $FORM{'newusername'};
	&usernamelegal($NewUserName);
	if ($LegalUsername eq "False") {
		&StandardHTML("Your new username, <b>$NewUserName</b>, was either a duplicate, left blank, or contained illegal charactors.  Please use your back button and submit a new name that corrects these problems.");
	} else {
		# Get the profile number
		$ProfileNumber = &GetUserNumber($OldUserName);
		# Open the profile in read mode
		open (PROFILEREAD, "$MembersPath/$ProfileNumber.cgi");
		# Write the contents of the profile to the variable @profile
		@profile = <PROFILEREAD>;
		# Closes profile
		close (PROFILEREAD);

		# Set the new username to $profile[0]
		$profile[0] = $NewUserName;

		# Open the profile in write mode
		open (PROFILEWRITE, ">$MembersPath/$ProfileNumber.cgi");
		# Print the new user name to the profile
		print PROFILEWRITE "$profile[0]\n";
		# Make every variable in profile $line
		foreach $line(@profile[1..15]) {
			# Print the $line
			print PROFILEWRITE "$line";
		}
		# Close the profile
		close(PROFILEWRITE);

		&usernamememberslist($NewUserName,$OldUserName);

		# Print ending HTML
		print qq~
<HTML>
<HEAD><TITLE>$BBName - Change UserName Successful</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="2" FACE="$FontFace" COLOR="$TextColor">
$Header
</font>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
<FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor"><B>Change UserName Successful</B></FONT>
<p>
<FONT SIZE="$TextSize" FACE="$FontFace">
Your username has been changed successfully and is now <b>$NewUserName</b>.  Please use this new name when posting notes.
<P>
If you made a typo while inputing your username, or would like to change it again, <A HREF="$CGIURL/ubbUserName.cgi">click here</A>.
<P>
$Footer
</FONT>
</BODY></HTML>
		~;
	}
}

###############################################################
# Subroutine that checks to see if the username is a duplicate
# or if it is an illegal name
###############################################################
sub usernamelegal {

	$LegalUsername = "True";

	# Begin duplicate check
	# Parse username to UBB's liking
	$NewUserName =~ s/\s+/ /g;
	# Get the Member List Array
	&GetMemberListArray;
	# Store something as $LCusername
	$LCusername = lc($NewUserName);
	# Check @members for duplicates
	CHECKDUPLICATELEGAL: for $checkthis(@members) {
		$LCcheckthis = lc($checkthis);
		if ($LCcheckthis eq "$LCusername") {
			$LegalUsername = ("False");
			last CHECKDUPLICATELEGAL;
		}
	}

	if ($Censor eq "ON") {
		@censored = split(/ /, $censorwords);
		CHECKCENSORLEGAL: for (@censored) {
			if (m/({)(.*)(})/) {
				$_ = ("$2");
			}
			if ($NewUserName =~ /$_/i) {
				$LegalUsername = "False";
				$CensorWord = $_;
				last CHECKCENSORLEGAL;
			}
		} 
	}

	if (($NewUserName eq "")||($NewUserName =~ m/^\s/)||($NewUserName =~ m/\&nbsp/)||($NewUserName =~ m/\s$/)||($NewUserName =~ m/\s{2,}/)||($NewUserName =~ m/\|\!/)||($NewUserName =~ m/\|\|/)||($NewUserName =~ m/\|$/)||($NewUserName =~ m/^\|/)||($NewUserName =~ m/></)||($NewUserName =~ m/memberslist/)||($NewUserName =~ m/emailfile/)||($NewUserName =~ m/;/) ||($NewUserName !~ /^[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']/)||($NewUserName !~ /[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']$/)) {
		$LegalUsername = "False";
	}
}


###############################################################
# Subroutine that rights the new username to the 
# memberslist.cgi file
###############################################################
sub usernamememberslist {

	open (LISTREAD, "$MembersPath/memberslist.cgi");
		while(chomp($this=<LISTREAD>)) { 
			($un,$pn) = split(/\|\!\!\|/, $this);
			if($un eq $OldUserName) {
				push (@newcontents, qq($NewUserName|!!|$pn\n)); 
			} else { 
				push (@newcontents, qq($un|!!|$pn\n)); 
			}
		}
	close LISTREAD;
	&Lock("lock.file");
	open (LISTWRITE, ">$MembersPath/memberslist.cgi");
		print LISTWRITE @newcontents;
	close LISTWRITE;
	&Unlock("lock.file");
	chmod (0666, "$MembersPath/memberslist.cgi");

}


###############################################################
# Subroutine that loads when a subroutine cannot be found
###############################################################
AUTOLOAD {
	&StandardHTML("Subroutine $AUTOLOAD not found.  Please contact the administrator of this bulliten board.");
}