#!/usr/bin/perl

######################################################################
#  IIS and WinNT may require the print line below.
#  If so, just remove the # at the beginning of the line.
######################################################################
# print "HTTP/1.0 200 OK\n";

eval
 {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
 
	################################################################
	# WinNT may require the full path to the files below
	################################################################

	require "setup.pl";
	require "subs1.pl";
	require "cgi-lib.pl";
	require "date.pl";
 };

 
######################################################################
######################################################################
############  You should not change anyting below. ###################
######### Your script may not work properly if you do ################
######################################################################
######################################################################

&ParseVarsArray;
$madmin=1;


######################################################################

if ($in{action} eq 'set')
 {
	$saveuse = $useids;
	undef $useids;
	&CheckInfo;
	$useids = $saveuse;
	&SetMainVars;	
 }
elsif ($in{action} eq 'login')
 {
	$saveuse = $useids;
	undef $useids;
	$LoggingIn = 1;
	&CheckInfo;
	$useids = $saveuse;
	&header("Admin");
	&MainVarsForm;
	&footer("Admin");
 }
else
 {
	$loginscript = $mainadminscript;
	&UserLogin;
 }

######################################################################

sub SetMainVars
 {
	if ($in{adminpw} ne $in{VerifyAdminPW})
	 {
		&PrintMessage(
			"Error",
			"Cannot change Administrator Password since the passwords you supplied 
			do not match.", 
			"",
			"Admin",
			"Admin"
			);
	 }
	
	open(FILE,">$base_dir/setup.$cgiext") || die "Can't open 'setup.$cgiext'\n";;
	if (!$DisableFlock) { flock(FILE,2); }
	print FILE $varsarray;
	print FILE "\n\n";
	print FILE "\n\n\n\n1;";
	if (!$DisableFlock) { flock(FILE,8); }
	close (FILE);
	
	&PrintMessage(
		"Update Complete",
		"Main variables have been updated", 
		"",
		"Admin",
		"Admin"
		);
		
	exit;
 }
 
######################################################################

sub MainVarsForm 
 {
	
	if (!$main_cgi_dir) { $main_cgi_dir = $cgi_dir; }

	if ($MainEnableAll eq $CurrentVerFormat) { $MainEnableAllChecked = 'checked'; }
	
	&CreateBarGraphSelectList;
	&GetLanguageList;
	

	$htmloutput .= qq~
	     <div align="center"><center>
		<h3>Script Administration</h3>
	       <form method="POST" action="$mainadminscript" name="ModifyMainVarsForm">
	       <input type="hidden" name="action" value="set">
	      <input type="hidden" name="id" value="$in{id}">
	      <input type="hidden" name="adminpw" value="$adminpw">
	      <input type="hidden" name="password" value="$in{password}">
	     <table border="0" width="100%" cellspacing="0" cellpadding="2">
	    <tr>
	      <td bgcolor="black" valign="top" colspan="2" align="center">
		<font face="$fontface" size="4" color="white">
		<strong>Main Variables</strong>
		</font>
	      </td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Enable All Contests and Surveys:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Check this box to enable all contests and surveys.<br>
		Not Checking this can be used for maintenance, upgrades or for whatever reason you have to shut them off.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="MainEnableAll" value="$CurrentVerFormat" $MainEnableAllChecked>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Shutoff Reason:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		you can enter a reason as to why all have been shutoff to inform the visitors and contest 
		administrators.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<textarea rows="4" name="MainShutoffReason" cols="30">$MainShutoffReason</textarea><br>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Local Submit Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Check this box to prevent <u>all</u> contest, survey and poll submissions from domains 
		other than this domain.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="LocalSubmitOnly" value="checked" $LocalSubmitOnly>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		Master Title:
		</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		A default title for all contests if one is not set.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="basictitle" size="34" value="$basictitle"></font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Master Email address:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Script admin email address for contest admins to contact if they need support.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="mainemail" size="34" value="$mainemail"></font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Admin ID:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		 Admin ID for setting master variables.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="adminid" size="15" value="$adminid"></font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Change Admin Password:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		 Type new admin password here if you are changing it.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="password" name="adminpw" size="15"></font>
		</td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Verify Admin Password:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		 You must type the new admin password here again if you are
		 changing it.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="password" name="VerifyAdminPW" size="15"></font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Title Logo:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		 The is the full or virtual HTTP path to the title logo.<br>
		 Example:<br>
		  http://www.domain.com/contests/title.gif<br>
		  ../images/title.gif
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="title_logo" size="34" value="$title_logo"></font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>CGI Directory:</strong></font><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		HTTP Path to cgi scripts without the trailing "/"<br>
		Example: http://www.domain.com/cgi-bin/uWCcontests
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<input type="text" name="main_cgi_dir" size="34" value="$main_cgi_dir">
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		Real Path:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Real path to scripts without the trailing "/"<br>
		Example NT path: d:/www/www.domain.com/cgi-bin/poll<br>
		Example UNIX path: /www/username/cgi-bin/poll
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="base_dir" size="34" value="$base_dir">
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Contest Directory:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Real path to directory to contest files without the trailing "/"<br>
		Example NT path: d:/www/www.domain.com/cgi-bin/poll/contests<br>
		Example UNIX path: /www/username/cgi-bin/poll/contests
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="contest_dir" size="34" value="$contest_dir">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Images Directory:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		HTTP path to the directory which stores the images. Without the trailing "/"<br>
		Example: http://www.domain.com/contests/images
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="image_dir" size="34" value="$image_dir">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">CGI Extension:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		This is the extension you will be using for the scripts.<br>
		By default this setting is "pl" but if you use another extension such as "cgi" you would define this here.<br>
		Do not include a period (.) with the extension. 
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="cgiext" size="5" value="$cgiext">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="#B8B8B8" valign="top" colspan="2" align="center">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Template Paths</strong>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	    <td colspan="2">
		    <table cellpadding="2" cellspacing="0">
		    <tr>
		    <tr>
		     <td bgcolor="$atablebgcolor1" valign="top" colspan="2">
			<font face="$fontface" color="$fontcolor" size="1">
			All template paths must real paths.<br>
			&nbsp;&nbsp;Example NT path: d:/www/www.domain.com/poll/template.htm<br>
			&nbsp;&nbsp;Example UNIX path: /www/username/poll/template.htm<br>
			All templates should reside in the same directory.  If they do not, it can result 
			in broken images, paths, and links in the HTML which is produced by this program.<br>
			<a href="$help_template" target="_blank">Click here</a> for more help with templates.
			</font>
			</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		     <td bgcolor="$atablebgcolor1" valign="top">
			<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Template:</font></strong><br>
			</td>
		      <td bgcolor="$atablebgcolor2" valign="top">
			<input type="text" name="main_tpl" size="60" value="$main_tpl"><br>
			<font face="$fontface" color="$fontcolor" size="1">
			If using ID's, this template will be used when viewing the
			list of all users.
			If you are not using ID's, this template will be used when viewing 
			the list of all contests, surveys, and polls.<br>
			Overrides below can be used.
			</font>
			</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		     <td bgcolor="$atablebgcolor1" valign="top">
			<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Contest Template:</font></strong><br>
			</td>
		      <td bgcolor="$atablebgcolor2" valign="top">
			<input type="text" name="mcontest_tpl" size="60" value="$mcontest_tpl"><br>
			<font face="$fontface" color="$fontcolor" size="1">
			If you are not using ID's, this template will be used when viewing 
			the list of all contests. It will also be used for every contest which does not 
			have a template defined in the Contest Variables.<br>
			Overrides below can be used.
			</font>
			</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		     <td bgcolor="$atablebgcolor1" valign="top">
			<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Survey Template:</font></strong><br>
			</td>
		      <td bgcolor="$atablebgcolor2" valign="top">
			<input type="text" name="msurvey_tpl" size="60" value="$msurvey_tpl"><br>
			<font face="$fontface" color="$fontcolor" size="1">
			If you are not using ID's, this template will be used when viewing 
			the list of all surveys. It will also be used for every survey which does not 
			have a template defined in the Survey Variables.<br>
			Overrides below can be used.
			</font>
			</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		     <td bgcolor="$atablebgcolor1" valign="top">
			<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Poll Template:</font></strong><br>
			</td>
		      <td bgcolor="$atablebgcolor2" valign="top">
			<input type="text" name="mpoll_tpl" size="60" value="$mpoll_tpl"><br>
			<font face="$fontface" color="$fontcolor" size="1">
			If you are not using ID's, this template will be used when viewing 
			the list of all polls. It will also be used for every poll which does not 
			have a template defined in the Poll Variables.<br>
			Overrides below can be used.
			</font>
			</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
		    </tr>
		    <tr>
		      <td valign="top" bgcolor="black" colspan="2"></td>
		    </tr>
		    <tr>
		      <td bgcolor="$atablebgcolor1" valign="top">
			<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
			Base Location<br>to Templates:
			</font></strong><br>
			</td>
		      <td bgcolor="$atablebgcolor2" valign="top">
			<input type="text" name="tpl_base" size="60" value="$tpl_base"><br>
			<font face="$fontface" color="$fontcolor" size="1">
			HTTP path to directory where the above defined templates exist.<br>
			Always use the trailing "/" at the end of the directory.<br>
			Example:<br>
			If the templates are located at:<br>
			&nbsp;&nbsp;http://www.domain.com/contests/template.htm<br>
			This path would be:<br>
			&nbsp;&nbsp;http://www.domain.com/contests/<br>
			<a href="$help_template" target="_blank">More Help</a>
			</font>
			</td>
		    </tr>
		    </table>
	    </td>
	    </tr>
	    
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="#B8B8B8" valign="top" colspan="2" align="center">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Template Overrides</strong>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">MASTER OVERRIDE:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="1">
		Check this box to <u>ONLY</u> use the Master Template defined above for <u>EVERYTHING</u>.
		The Master Template will override EVERY template which can defined 
		through the Contest Administration (admin.pl) as well as the templates defined above for 
		Master Contest Template, Master Survey Template, and Master Poll Template.<br>
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="DefaultTplOnly" value="checked" $DefaultTplOnly>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Template Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="1">
		Check this box to <u>only</u> use the Master Template defined above 
		when viewing the list of users or viewing the list of all contests,
		surveys, and polls for every user.
		The Master Template will override <u>every</u> main template which can defined 
		through the Contest Administration (admin.pl).
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="MasterTplOnly" value="checked" $MasterTplOnly>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Contest Template Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="1">
		Check this box to use the Master Contest Template defined above for <u>ALL
		CONTESTS</u>. The Master Contest Template will override <u>every contest template</u>
		which can defined through the Contest Administration (admin.pl).
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="MasterContestTplOnly" value="checked" $MasterContestTplOnly>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Survey Template Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="1">
		Check this box to use the Master Survey Template defined above for <u>ALL
		SURVEYS</u>. The Master Survey Template will override <u>every survey template</u>
		which can defined through the Contest Administration (admin.pl).
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="MasterSurveyTplOnly" value="checked" $MasterSurveyTplOnly>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Master Poll Template Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="1">
		Check this box to use the Master Poll Template defined above for <u>ALL
		POLLS</u>. The Master Poll Template will override <u>every poll template</u>
		which can defined through the Contest Administration (admin.pl).
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="MasterPollTplOnly" value="checked" $MasterPollTplOnly>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Create Contests - Admin Only:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Check this if you want the script admin to be the only person who can create new contests.<br>
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="admincreateonly" value="checked" $admincreateonly>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		Email Process to use:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		CHECK this box TO USE sockets.<br>
		DO NOT check this box if you are using SendMail.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="checkbox" name="socketsend" value="checked" $socketsend>
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		SMTP Sever:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		This is the SMTP server that you will use for delivering email when using sockets.<br>
		Example: smtp.domain.com<br>
		This can be left blank if you are using SendMail.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="smtpserver" size="34" value="$smtpserver">
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		SendMail Location:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Real path to your sendmail program for UNIX.<br>
		Example: /usr/sbin/sendmail<br>
		This can be left blank if you are using sockets.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="mailprog" size="34" value="$mailprog">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	   
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Table background color 1:</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Default table background color to be used for admin screens only.<br>
		Example: red<br>
		Example: #EFEFE0
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="atablebgcolor1" size="10" value="$atablebgcolor1">
		</font>
		</td>
	    </tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">
		Table background color 2:
		</font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Default table background color to be used for admin screens only.<br>
		Example: red<br>
		Example: #EFEFE0
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="atablebgcolor2" size="10" value="$atablebgcolor2">
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Font face: </font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Default font face(s) to be used.
		Example: arial, verdana
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="afontface" size="20" value="$afontface">
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Font size: </font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Fonts size to be used.<br>
		Example: 3
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="afontsize" size="5" value="$afontsize">
		</font>
		</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<strong><font face="$fontface" color="$fontcolor" size="$fontsize">Text color: </font></strong><br>
		<font face="$fontface" color="$fontcolor" size="-2">
		Default Text color.<br>
		Example: black<br>
		Example: #000000
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="afontcolor" size="10" value="$afontcolor">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>


	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$afontface" color="$afontcolor">
		<strong><font size="$afontsize">Default Bar Graph Color: </font></strong><br>
		<font size="-2">
		The color to be used for the bar graph when displaying results.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<select name="DotColor">
		$BarGraphImageSelect
		</select>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$afontface" color="$afontcolor">
		<strong><font size="$afontsize">Overriding Bar Graph Image: </font></strong><br>
		<font size="-2">
		If you would like to use a custom image that is used for <u>ALL</u> contests, surveys, and 
		polls, place the HTTP path to that image here. If you set this value, Contest Admins 
		will not be able to be set their own colors or custom images for the bar graphs.
		If you want to allow Contest Admins to define there own colors 
		or custom images, leave this blank.
		<p>
		The pixel dimensions of the outputed bar graphic depends on the font size and 
		the percentage of votes. The height will be 4 times the value you have set
		for your font size. The length will be between 1 and 100 pixels depending
		on the percentage of entries.
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font size="3">
		<input type="text" name="MasterTotalBarImage" value="$MasterTotalBarImage" size="34">
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>

	    <tr>
	      <td bgcolor="$atablebgcolor1" valign="top">
		<font face="$fontface" color="$fontcolor" size="$fontsize">
		<strong>Disable flock (File Locking) function:</strong><br>
		</font>
		<font face="$fontface" color="$fontcolor" size="-2">
		If your platform does not support the <u>flock</u> function, you can 
		disable it by checking this box. More than likely your platform will
		let you know if the flock function is not implemented by displaying
		an error when you run this program. If you don't get any
		errors or you are unsure, it is best to leave this box unchecked. 
		</font>
		</td>
	      <td bgcolor="$atablebgcolor2" valign="top">
		<font face="$fontface" color="$fontcolor" size="3">
		<input type="checkbox" name="DisableFlock" value="checked" $DisableFlock><br>
		<font size="1" color="red">
		Note: Checking this box and disabling the flock function may result 
		in data loss. You should never disable the file locking (flock) unless
		you have to.
		</font>
		</font>
		</td>
	    </tr>

	    <tr>
	      <td valign="top" bgcolor="black" colspan="2"></td>
	    </tr>
	    <tr>
	      <td valign="top" colspan="2"> &nbsp;&nbsp;</td>
	    </tr>
		</table>
		<p><font face="$fontface" color="$fontcolor" size="$fontsize">

	~;
	
	if (!$demo)
	 {
		$htmloutput .= qq~
			<input type="submit" value="Modify Main Variables" name="SubmitButton">
			&nbsp;&nbsp;&nbsp;&nbsp;
			<input type="reset" value="Reset" name="ResetButton" >
		~;
	 }
	else
	 {
		$htmloutput .= qq~
			<input type="reset" value="Modifications to the Main Variables have been disabled">
		~;
	 }
	$htmloutput .= qq~

		</font>
		</p>
		</center></div>
		</form>


	~;

	&CreateContestForm;	
 }

######################################################################

exit;